Skip to main content

extraInfo

Description

Optional. Adds additional information about files/folders to the preview panel

Usage

extraInfo?: (
file: {
id: string,
type?: "file" | "folder",
size?: number,
lazy?: boolean,
date?: Date,
parent: string,
name: string,
ext: string,
$level: number,
open?: boolean,
data?: {
id: string,
type?: "file" | "folder",
size?: number,
lazy?: boolean,
date?: Date,
parent: string,
name: string,
ext: string,
$level: number,
open?: boolean,
data?: any[],
[key: string]: any,
}[],
[key: string]: any,
}
) => {
Size: string,
Count: string,
[key: string]: any,
} | Promise<{
Size: string,
Count: string,
[key: string]: any,
}> | null;

Parameters

The function takes an object of a file/folder as an input with the next parameters:

file – (required) the file or folder entity for which extra information should be provided.
It includes the following properties:

  • id – (required) unique identifier of the file or folder
  • type? - (optional) it can be "file" | "folder"` that indicates whether the entity is a file or folder
  • size – (optional) the size of the file in bytes (folders may omit this)
  • lazy – (optional) if true, children are loaded on demand
  • date – (optional) last modification or creation date
  • parent – (required) ID of the parent folder
  • name – (required) the name of the file or folder
  • ext – (required) file extension; empty string for folders
  • $level – (required) depth level of the entity in the tree structure
  • open – (optional) whether the folder is expanded in the UI
  • data – (optional) nested children (if any), each with the same structure as file
  • [key: string]: any – additional metadata fields provided by the backend

Returns one of the following: promise with ExtraInfo, ExtraInfo or null (no extra information is shown).

ExtraInfo: {
Size: string; // Human-readable size (e.g., "12 MB")
Count: string; // Number of items in a folder
[key: string]: any; // Custom metadata fields
}

Example

The example below demonstrates how to load data from the server adding extra information. The requestInfo function returns an object with the size data for folders and an object with metadata for JPG files.

<script setup>
import { Filemanager } from "@svar-ui/vue-filemanager";
import { formatSize } from "@svar-ui/vue-filemanager";
import { ref } from "vue";

const server = "https://some-backend-url";

const rawData = ref([]);
fetch(server + "/files")
.then((data) => data.json())
.then((data) => (rawData.value = data));

function requestInfo(file) {
if (file.type == "folder" || file.ext == "jpg") {
return fetch(server + "/info/" + encodeURIComponent(file.id)).then((data) => {
if (data.ok) {
return data.json().then((d) => {
if (file.type == "folder") d.Size = formatSize(d.Size);
return d;
});
}
});
}
}

</script>

<template>
<Filemanager :data="rawData" :extraInfo="requestInfo" />
</template>

Related articles:

Related samples: Extra Info

Skip to main content

extraInfo

Description

Optional. Adds additional information about files/folders to the preview panel

Usage

extraInfo?: (
file: {
id: string,
type?: "file" | "folder",
size?: number,
lazy?: boolean,
date?: Date,
parent: string,
name: string,
ext: string,
$level: number,
open?: boolean,
data?: {
id: string,
type?: "file" | "folder",
size?: number,
lazy?: boolean,
date?: Date,
parent: string,
name: string,
ext: string,
$level: number,
open?: boolean,
data?: any[],
[key: string]: any,
}[],
[key: string]: any,
}
) => {
Size: string,
Count: string,
[key: string]: any,
} | Promise<{
Size: string,
Count: string,
[key: string]: any,
}> | null;

Parameters

The function takes an object of a file/folder as an input with the next parameters:

file - (required) the file or folder entity for which extra information should be provided. It includes the following properties:

  • id - (required) unique identifier of the file or folder
  • type? - (optional) it can be "file" | "folder"` that indicates whether the entity is a file or folder
  • size - (optional) the size of the file in bytes (folders may omit this)
  • lazy - (optional) if true, children are loaded on demand
  • date - (optional) last modification or creation date
  • parent - (required) ID of the parent folder
  • name - (required) the name of the file or folder
  • ext - (required) file extension; empty string for folders
  • $level - (required) depth level of the entity in the tree structure
  • open - (optional) whether the folder is expanded in the UI
  • data - (optional) nested children (if any), each with the same structure as file
  • [key: string]: any - additional metadata fields provided by the backend

Returns one of the following: promise with ExtraInfo, ExtraInfo or null (no extra information is shown).

ExtraInfo: {
Size: string; // Human-readable size (e.g., "12 MB")
Count: string; // Number of items in a folder
[key: string]: any; // Custom metadata fields
}

Example

The example below demonstrates how to load data from the server adding extra information. The requestInfo function returns an object with the size data for folders and an object with metadata for JPG files.

import { useState, useEffect } from "react";
import { Filemanager } from "@svar-ui/react-filemanager";
import { formatSize } from "@svar-ui/react-store";

const server = "https://some-backend-url";

export default function ExampleFilemanager() {
const [rawData, setRawData] = useState([]);

useEffect(() => {
fetch(server + "/files")
.then((res) => res.json())
.then((data) => setRawData(data))
.catch((err) => {
console.error("Failed to load files:", err);
});
}, []);

// extraInfo prop: may return ExtraInfo or a Promise<ExtraInfo>
function requestInfo(file) {
if (file.type === "folder" || file.ext === "jpg") {
return fetch(server + "/info/" + encodeURIComponent(file.id)).then((res) => {
if (res.ok) {
return res.json().then((d) => {
if (file.type === "folder") d.Size = formatSize(d.Size);
return d;
});
}
return null;
});
}
return null;
}

return <Filemanager data={rawData} extraInfo={requestInfo} />;
}

Related articles:

Related samples: Extra Info